% kakote (prononcer kakoté) est une classe, créée par Papiray, inspiré par le nom de sa mère KAtica (en slave, la lettre "c" se prononce tSe, donc prononcer KatiTSA) KOmljenovic (la syllabe "Kom" se prononce Komm', la syllabe "lje" se prononce lié et la syllabe ``novic'' se prononce novitch), née à Mostar, avec un clin d'oeil au signifié bosniaque (kako te) ou serbe (kako ti) d'une expression qui se traduit par "comment tu ?" ou "comment vous ?". kakote est un ensemble "compilatoire" destinée à l'écriture d'un livre sans formules mathématiques qui trouve son inspiration dans la classe "xmemoire" de "gitorious.org", classe pour XeLaTeX et LaTeX, qui doit elle-même son existence à la classe "bredele" développée par Christophe Masutti. Elle participe également de KOMA-script et de babel{french} pour le travail "format & typographie" à la française. Elle est utilisée avec XeLaTeX.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% This program is free software: you can redistribute it and/or modify  it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{kakote}[13/07/2016]

\LoadClass[12pt, BCOR=12mm, twoside=semi, DIV=calc, headsepline, parskip]{scrbook}  
\KOMAoptions{captions=bottombeside} 

\RequirePackage{fontspec} % le pack fontspec importe xltxtra - qui lui-même importe metalogo (qui fournit les logos LaTeX & XeLaTeX) et fixltx2e (qui fournit la commande \subscript pour écrire des index en mode texte)
\RequirePackage{xunicode}  % permet de reconnaitre les caractères accentués du clavier dont le texte source est codé en utf8, et dont l'appel n'est pas à faire avec  (french) babel.

\RequirePackage{scrdate}

% pour éviter l'erreur de compilation - Classe Erreur Scrbook: undefined ancienne commande de police \rm - ajouter dans le préambule
\renewcommand{\rm}{\rmfamily} 
\renewcommand{\sf}{\sffamily} 
\renewcommand{\tt}{\ttfamily} 
\renewcommand{\bf}{\bfseries} 
\renewcommand{\sc}{\scshape}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\RequirePackage{ifpdf}
\RequirePackage[usenames,dvipsnames,svgnames,table]{xcolor} 
% L’option usenames permet d’utiliser 16 noms de couleurs prédéfinies, les même couleurs de base qu’en HTML.
% L’option dvipsnames permet d’accéder à 64 couleurs de plus 
% L’option svgnames permet d’accéder jusqu’à 150 couleurs au total.
% L’option table permet d’utiliser ces couleurs en plaçant la commande color juste avant un tableau géré par tabu.
% De base, LaTeX permet d’utiliser les couleurs white, black, red, green, blue, cyan, magenta et yellow..

%%%%%%%%%%%%%%%%%%%%%%%%%

\DeclareRobustCommand*{\Macro}[1]{\mbox{\texttt{\char`\\#1}}}
\DeclareRobustCommand*{\Option}[1]{\mbox{\texttt{#1}}}
\DeclareRobustCommand*{\KOption}[1]{\mbox{\Option{#1}\texttt=}}
\DeclareRobustCommand*{\OptionValue}[2]{\mbox{\texttt{#1=#2}}}
\DeclareRobustCommand*{\FloatStyle}[1]{\mbox{\texttt{#1}}}
\DeclareRobustCommand*{\Pagestyle}[1]{\mbox{\texttt{#1}}}
\DeclareRobustCommand*{\Environment}[1]{\mbox{\texttt{#1}}}
\DeclareRobustCommand*{\Counter}[1]{\mbox{\texttt{#1}}}
\DeclareRobustCommand*{\Length}[1]{\mbox{\texttt{\char`\\#1}}}
\DeclareRobustCommand*{\PLength}[1]{\mbox{\PValue{#1}}}
\DeclareRobustCommand*{\Variable}[1]{\mbox{\PValue{#1}}}
\DeclareRobustCommand*{\FontElement}[1]{\PValue{#1}}
\DeclareRobustCommand*{\PName}[1]{\texttt{\textit{#1}}}
\DeclareRobustCommand*{\PValue}[1]{\texttt{#1}}
\DeclareRobustCommand*{\Parameter}[1]{\texttt{\{}\PName{#1}\texttt{\}}}
\DeclareRobustCommand*{\OParameter}[1]{%
  \texttt{[%]
  }\PName{#1}\texttt{%[
    ]}}
\DeclareRobustCommand*{\AParameter}[1]{%
  \texttt{(%)
  }\PName{#1}\texttt{%(
    )}}
\DeclareRobustCommand*{\PParameter}[1]{\texttt{\{#1\}}}
\DeclareRobustCommand*{\POParameter}[1]{\texttt{[#1]}}

%%% Pour créer et gérer ses dessins ou schémas

\RequirePackage{tikz} 
\usetikzlibrary{calc}

%%% Pour faire des encarts comme Markus, avec un environnement nommé ShowOutput

%\begin{environment}{ShowOutput}
%   This environment is used for the output of examples. It shows the middle
%   part of a page\footnote{TODO: optional arguments for printing a top or
%     bottom part of a page}. It uses |\scalebox| so you should never use a
%   DVI preview or a raw DVI printing.
%    \begin{macrocode}
\newsavebox\ShowOutputBox
\newenvironment{ShowOutput}[1][0pt]{\par
  \begin{lrbox}{\ShowOutputBox}%
    \minipage{.9\linewidth}%
      \vspace*{\baselineskip}\vspace{-#1}%
}{%
    \endminipage
  \end{lrbox}%
  \setlength{\unitlength}{1pt}%
  \setlength{\@tempdima}{\ht\ShowOutputBox}%
  \addtolength{\@tempdima}{\dp\ShowOutputBox}%
  \setlength{\@tempdima}{.75\@tempdima}%
  \edef\MidY{\strip@pt\@tempdima}%
  \addtolength{\@tempdima}{5pt}%
  \edef\HighY{\strip@pt\@tempdima}%
  \addtolength{\@tempdima}{-10pt}%
  \edef\LowY{\strip@pt\@tempdima}%
  \addtolength{\@tempdima}{5pt}%
  \setlength{\@tempdima}{.9\linewidth}\edef\QuadIV{\strip@pt\@tempdima}%
  \setlength{\@tempdima}{.675\linewidth}\edef\QuadIII{\strip@pt\@tempdima}%
  \setlength{\@tempdima}{.45\linewidth}\edef\QuadII{\strip@pt\@tempdima}%
  \setlength{\@tempdima}{.225\linewidth}\edef\QuadI{\strip@pt\@tempdima}%
  \centering
  \begin{picture}(\QuadIV,\MidY)
     \qbezier(0,\MidY)(\QuadI,\HighY)(\QuadII,\MidY)%
     \qbezier(\QuadII,\MidY)(\QuadIII,\LowY)(\QuadIV,\MidY)
     \put(0,0){\makebox(\QuadIV,\MidY)[c]{%
         \scalebox{.75}{\usebox{\ShowOutputBox}}%
       }%
     }%
     \put(0,-5){\line(0,1){\HighY}}%
     \put(\QuadIV,-5){\line(0,1){\HighY}}%
     \qbezier(0,-5)(\QuadI,0)(\QuadII,-5)%
     \qbezier(\QuadII,-5)(\QuadIII,-10)(\QuadIV,-5)
  \end{picture}\par  
  \vspace{1ex plus 1ex minus .5ex}%
}
%    \end{macrocode}
% \end{environment}

%%%%%%%%%%%%%%%%%%%%%%%%%

\RequirePackage{listings}
% Setup listings:
%    \begin{macrocode}
\lstdefinestyle{basics}{%
  basicstyle=\ttfamily,%
  columns=fullflexible,keepspaces,%
  aboveskip=.4\baselineskip,%
  belowskip=0pt%
}%
\lstdefinestyle{code}{%
  style=basics,%
  language=[LaTeX]TeX,%
  moretexcs={%
    @auxout, @currext, @dottedtocline, @empty, @float, @ifpackagelater,
    @ifundefined,
    @rightmark, @secondoftwo, @tempswafalse,@tempswatrue, @undefined,
    AtBeginDocument,AtEndDocument, appendix, ClassWarningNoLine,CurrentOption,
    color,colorbox,
    DeclareOption,DeclareRobustCommand,dimexpr, end@float, ExecuteOptions,
    if@filesw,if@tempswa,if@twoside, includegraphics, MessageBreak,
    onehalfspacing,
    PackageError,PackageInfo,PackageWarning,PassOptionsToPackage,
    ProcessOptions,protected@write,ProvidesFile,ProvidesPackage,
    providecommand,
    RequirePackage,RequirePackageWithOptions,setkey,setlength,
    SelectInputMappings,setkeys,
    textsuperscript}%
}%
\lstdefinestyle{output}{%
  style=basics,breaklines,prebreak=\mbox{$\hookleftarrow$}%
}%
\lstdefinestyle{KOMA}{%
  style=code,%
  moretexcs={%
    @addtoplength,@setplength,@newplength, activateareas,
    addchap,addrentry,Address,addcontentslinetoeachtocfile,
    addxcontentslinetoeachtocfile,addsec,
    addtoeachtocfile,
    addtokomafont,addtolengthplength,addtoreffields,addtotoclist,
    adrchar,adrentry,
    AddLayersAtBeginOfPageStyle,AddLayersToPageStyle,
    AfterBibliographyPreamble,AfterCalculatingTypearea,
    AfterFile,AfterPackage,AfterStartingTOC,AfterTOCHead,
    appendixmore,appendixname,areaset,autodot,automark,AtAddToTocList,
    AtBeginLetter,
    BeforeFamilyProcessOptions,
    BeforeClosingMainAux,BeforePackage,bib@beginhook,bib@endhook,
    blinddocument,blindtext,Blinddocument,Blindtext,
    cc,captionabove,captionaboveof,captionbelow,captionbelowof,captionformat,
    captionof,cefoot,cfoot,chapapp, chapappifchapterprefix,
    chapter,chapterlinesformat,chapterlineswithprefixformat,
    chapterformat,chaptermarkformat,chapterpagestyle,chead,
    Clause,
    cleardoubleevenemptypage,clearscrheadfoot,closing,cofoot,Comment,
    CloneTOCEntryStyle,
    DeclareLayer,DeclareNewLayer,DeclareNewPageStyleByLayers,
    DeclarePageStyleByLayers,
    DeclareTOCStyleEntry,DeclareTOCEntryStyle,
    DeclareNewNoteColumn,DeclareNewPageStyleAlias,
    DeclareNewTOC,DeclareSectionCommand,DeclareNewSectionCommand,
    RedeclareSectionCommand,ProvideSectionCommand,
    dedication,defcaptionname,deffootnote,deffootnotemark,
    DefineFamily,DefineFamilyKey,
    DefineFamilyMember,DestroyLayer,defpagestyle,deftripstyle,
    dictum,dictumauthorformat,dictumrule,dictumwidth,doforeachtocfile,
    ellipsispar,
    encl,extratitle,FamilyBoolKey,FamilyExecuteOptions,
    FamilyKeyState,FamilyKeyStateUnknown,FamilyKeyStateProcessed,
    FamilyKeyStateUnknownValue,FamilyKeyStateNeedValue,
    FamilyNumericalKey,%
    FamilyOption,FamilyOptions,FamilyProcessOptions,FamilySetBool,
    FamilyStringKey,
    figureformat,figurename,firstfoot,firsthead,FirstName,footfont,footref,
    ForEachLayerOfPageStyle,
    FreeI,FreeII,FreeIII,FreeIV,
    GenericMarkFormat,
    headfont,headmark,
    ifundefinedorrelax,
    ifattoclist,ifoot,ihead,ifkomavarempty,ifstr,ifthispageodd,InputAddressFile,
    KOMAoption,KOMAoptions,KOMAScript, l@addto@macro,
    LastName,layerwidth,layerheight,lefoot,lehead,LetterOptionNeedsPapersize,
    LenToUnit,
    lipsum,listoffigures,
    listoftables,listoftoc,LoadLetterOption,lofoot,lohead,lowertitleback,
    MakeMarkcase,makenote,maketitle,manualmark,marginline,minisec,
    multfootsep,multiplefootnoteseparator,
    Name,nameday,newbibstyle,newcaptionname,newkomavar,nexthead,
    ofoot,ohead,opening,othersectionlevelsformat,
    p@section,pagemark,paragraphformat,subparagraphformat,
    parellipsis,parformat,parname,parshortname,
    part,partformat,partname,partpagestyle,pnumfont,
    PreventPackageFromLoading,providecaptionname,publishers,ps,
    putLL,putLR,putUL,putUR,putC,
    raggedsection,raggedpart,raggedsignature,recalctypearea,
    refL,refS,refN,refoot,
    refParagraph,refParagraphN,refPar,refParL,refParS,refParN,
    refSentence,refSentenceL,refSentenceS,refSentenceN,rehead,
    RelaxFamilyKey,
    removereffields,renewcaptionname,
    RedeclarePageStyleAlias,
    ReplaceInput,ReplacePackage,ResetPreventPackageFromLoading,
    rohead,
    sectionformat,subsectionformat,subsubsectionformat,
    sectionmarkformat,sectioncatchphraseformat,sectionlinesformat,
    Sentence,sentencename,sentenceshortname,
    setbibpreamble,setcapindent,setcapwidth,
    setchapterpreamble,setfootbotline,setfootsepline,setfootwidth,
    setheadsepline,setheadtopline,setheadwidth,setindexpreamble,setkomafont,
    setkomavar,setlengthtoplength,setparsizes,setpartpreamble,setuptoc,
    showfields,showenvelope,showISOenvelope,showUScommercial,showUScheck,
    storeareas,StorePreventPackageFromLoading,
    subject,SubClause,subsectionmarkformat,subtitle,syncwithnotecolumn,
    tableformat,tablename,tableofcontents,textsubscript,thechapter,thefigure,
    thefootnotemark,thepar,thepart,thesection,thesentence,thesubsection,
    thesubsubsection,theparagraph,thesubparagraph,
    thetable,thistime,
    titlehead,tocbasic@extend@babel,TOCclone,todaysname,typearea,%
    TOCEntryStyleInitCode,TOCEntryStyleStartInitCode,TOCLineLeaderFill,
    UnPreventPackageFromLoading,unitfactor,
    unsettoc,usekomafont,useplength,usekomavar,uppertitleback% 
}%
} \lstset{style=basics} \lstnewenvironment{lstoutput}[1][]{%
  \lstset{style=output,basicstyle=\ttfamily\small,#1}%
}{} \lstnewenvironment{lstcode}[1][]{%
  \lstset{style=KOMA,basicstyle=\ttfamily\small,#1}%
}{} \newcommand*{\lstinputcode}[1][]{%
  \lstinputlisting[style=KOMA,basicstyle=\ttfamily\small,#1]%
}
%    \end{macrocode}
%

% mise en place du texte et gestion images et logos dans les paragraphes (ou alinéas)

\setlength{\parindent}{3mm} % règle l'indentation des paragraphes selon les règles typographiques communément admises.( si = 0, l'indentation est supprimée) - pour définir l'indentation par défaut de tous les paragraphes, entrer cette ligne en préambule
\parskip=4pt % règle l'espace entre les paragraphes

\widowpenalty=10000 % empêche au maximum la coupure avant la derniere ligne
\clubpenalty=10000  % empêche au maximum la coupure apres la premiere ligne
\raggedbottom  % empeche l'étirement des ressorts verticaux

% gestion des césures dans les mots pour éviter les débordements dans la marge

\hyphenpenalty-100% ou -500 tant qu'à faire ;)
%\doublehyphendemerits-2000
\finalhyphendemerits-1000

\RequirePackage{pifont} %fournit des logos - attention ce pack est chargé par et avec csquotes
\RequirePackage{marvosym} % liste des symboles dans la doc du paquet

%\newcommand\aze{\MVAt{marvosym}} % pour logo arobase marvosym 
%\newcommand\flic{\mvchr{33}} % pour logo stop marvosym 
%\newcommand\tlfon{\mvchr{72}} % pour logo téléphone marvosym
%\newcommand\main{\mvchr{90}} % pour logo main index tendu marvosym
%\newcommand\stilo{\mvchr{98}} % pour logo main stylo marvosym

% \relsize{2} pour modifier la taille du logo

%\RequirePackage{kpfonts} % liste des symboles dans la doc du paquet
\RequirePackage{hologo} % qui fournit 64 logos et variantes LaTeX -  XeLaTeX ...

\RequirePackage{bclogo} % La syntaxe \usepackage{bclogo} est équivalente à \usepackage[pstricks]{bclogo}

%Extensions indispensables à l'utilisation de bclogo

\RequirePackage{mdframed} % charge les packs kvoptions - xparse - etoolbox - color
\RequirePackage{graphicx} % attention ce pack est chargé par et avec csquotes
%\RequirePackage{xkeyval}  % pack chargé nomalement par kvoptions - xparse - etoolbox - color
\RequirePackage{ifthen}

% gestion de l'organisation

\RequirePackage{sectsty} % obligatoire, pour jouer avec l'apparence des titres
%\RequirePackage{shorttoc} % pour le sommaire, au début.

\graphicspath{{imgs/}} % stocker toutes mes images dans un dossier que j'appelle ici imgs (mais en réalité comme l'on veut)
\DeclareGraphicsExtensions{.png,.jpg,.tif,.pdf} % permet d'utiliser une image en ''oubliant'' son extension
 
 \RequirePackage{wrapfig} % permet d'insérer une image entourée de texte avec précision dans un paragraphe
 \RequirePackage{import} % option recommandée pour insérer des fichiers dans la composition d'un long document, style différents chapitres dans scrbook
  
% longtable - commandes spécifiques de gestion

\RequirePackage{tabularx} 
%\usepackage{array} est chargé automatiquement par tabularx

\RequirePackage{tabu} % L'intérêt de l'extension tabu est qu'elle étend les fonctionnalités des extensions tabularx, array et longtable tout en ajoutant un certain nombre de fonctionnalités nouvelles intéressantes. Les extensions xcolor (avec l'option table), ragged2e, numprint (ou siunitx selon les besoins) et longtable doivent être chargées si l'on souhaite tirer parti de toutes les possibilités offertes par tabu.
 
 \RequirePackage{ragged2e} % Fournit les commandes \Centering, \RaggedRight et \RaggedLeft, ainsi que les environnements Center, FlushLeft et Flushright pour que les portions de texte non justifiées aient des lignes de longueurs plus homogènes.
 
\RequirePackage{numprint}

\RequirePackage{longtable}

\RequirePackage{arydshln} %  hdashline et cdashline sont les équivalents de hline et cline pour les pointillés - la ligne verticale pointillée utilise le descripteur : à la place de |.

\let\oldlongtable=\longtable % permet de contrôler la taille de la police de toutes les tables en une seule fois
\def\longtable{\small\oldlongtable} % permet de contrôler la taille de la police de toutes les tables en une seule fois

\let\oldtabular=\tabular % permet de contrôler la taille de la police de toutes les tables en une seule fois
\def\tabular{\small\oldtabular} % permet de contrôler la taille de la police de toutes les tables en une seule fois

\let\oldtable=\table % 
\def\table{\small\oldtable} % permet de contrôler la taille de la police de toutes les tables en une seule fois

% sidewaystable du package rotating tourne automatiquement un tableau de 90 ou 270 degrés selon qu’il se trouve sur une page paire ou impaire - il sera forcément placé seul sur une page.
\RequirePackage{rotating} %\begin{sidewaystable} \centering --- le tableau pivoté --- \end{sidewaystable}

% commandes spécifiques pour gérer l'utilisation du paq KOMA

\RequirePackage{float} % pour utiliser l'option de placement [H] au lieu de [h!] chargé dans MikTeX 2.9
%\RequirePackage{floatrow} %  chargé dans MikTeX 2.9
\RequirePackage{scrhack} % patches pour float.sty, floatrow.sty, (anciennes versions) hyperref, listings, et setspace
\RequirePackage{typearea} % paquet KOMA-Script
\RequirePackage{scrkbase} % paquet KOMA-Script interne

% indiquer les numéros de ligne

\RequirePackage{verse}

\RequirePackage{dashrule}

%%%%%%% Ne pas oublier Hyperref pour interactions
\RequirePackage{hyperref}
\hypersetup{colorlinks=true,
				citecolor=black,
				filecolor=black,
				linkcolor=black,
				urlcolor=black,
				bookmarks=false}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%ù

%gestion des espaces

\RequirePackage{xspace} % utile pour gérer des espaces corrects
\RequirePackage[onehalfspacing]{setspace} 
\AfterTOCHead{\singlespacing} 
\singlespacing 

% approche typographique

\RequirePackage{relsize} % \relsize{n} permet d'augmenter (n positif) ou de diminuer (n négatif) la taille de la fonte par rapport à la taille courante.

\defaultfontfeatures{ligatures=TeX,Scale=MatchLowercase} % nécessite fontspec - uniformise la hauteur des minuscules

\RequirePackage{hyphenat}

\RequirePackage{eurosym} %pour écrire le symbole euro
\RequirePackage[normalem]{ulem} % ulem permet de souligner ou de rayer un mot - normalem en option évite les titres des références soulignées au lieu d’être en italique

\RequirePackage{soulutf8} % permet d'étirer un mot, même avec des accents



% utilisation d'une première lettre travaillée

\RequirePackage{lettrine}

% citation d'url

\RequirePackage{url}

% citation de code

\RequirePackage{listings}

\RequirePackage{example}

\RequirePackage{amssymb} % insertion d'expressions, de symboles (mathématiques et/ou autres).

\RequirePackage[babel=true]{csquotes}

\RequirePackage{showexpl} % gère le code, son affichage et l'affichage du résultat en une seule étape

\RequirePackage{shortvrb}
\MakeShortVerb{§} % pour créer un raccourci (ici §) encadrant une commande longue afin de la rendre inactive lors de l'édition de la description de cette commande
 % lstlinline{blablabla-codendur} % autre raccourci encadrant une commande courte dans une ligne de texte afin de la rendre inactive lors de l'édition de la description de cette commande

\RequirePackage{boxedminipage} % pour encadrer directement le contenu d'un paragraphe.

\RequirePackage{remarkbox}

\RequirePackage{tocbasic} % pour encadrer directement le contenu d'un paragraphe.avec remarkbox

\RequirePackage{verbatim}  % insère texte brut, pour accéder aux environnements verbatim et verbatimtab. Dans l'environnement verbatim après \begin{verbatim}, la seule commande identifiée est \end{verbatim}.
\newsavebox{\verbbox} % verbatim ne peut être utilisé comme argument dans \parbox \mbox \makebox ou \fbox. 
\RequirePackage{moreverb} % insère du texte brut avec des délimiteurs spécifiques - permet d'utiliser \begin{listing}
\RequirePackage{alltt} % pour  interpréter une commande dans l'environnement verbatim, employer l'extension alltt à la place
\RequirePackage{fancyvrb} % pour accéder à un environnement verbatim

\RequirePackage{tocloft} % Personnalisation apparence tables des matières, figures et tableaux 
\RequirePackage{fancybox} % définit 4 styles de boîtes qui se comportent comme - fbox. 
\RequirePackage[Lenny]{fncychap} % six styles [] Sonny - Lenny - Glenn - Conny - Rejne - Bjarne 
\RequirePackage{framed} % crée 3 environnements se comportant comme des minipages. 

% manipulation des notes de marge

\reversemarginpar % Pour inverser les notes dans les marges (droite/gauche) - proposition de grappa - univ-lille
\setlength{\marginparwidth}{60pt} % largeur de note dans la marge

\newcommand\notemarge[1]{%
\marginpar[footnotesize][\raggedleft #1]{\raggedright #1}}

\RequirePackage{endnotes} % ligne à ajouter dans le préambule 
%\endnote{Texte de la note.} % à ajouter dans le corps du texte, là où on veut créer l'appel de note (la syntaxe est analogue à celle de la commande footnote).
%\theendnotes % à ajouter là où on veut que la note apparaisse.

\RequirePackage{marginnote}

\RequirePackage{todonotes} % pour changer la taille et la famille de la police dans la note de marge 
%\renewcommand{\marginfont}{\tiny} % fixe la taille de la police dans la note de marge 
%\renewcommand{\marginfont}{\scriptsize} % fixe la taille de la police dans la note de marge 
\renewcommand{\marginfont}{\footnotesize} % fixe la taille de la police dans la note de marge 
%\renewcommand{\marginfont}{\small} % fixe la taille de la police dans la note de marge 

% Quand les notes de marge ne ​​sont pas placées correctement, utiliser dans l'environnement framed

\begingroup
\makeatletter
\g@addto@macro\framed {%
\let\marginnoteleftadjust\FrameSep
\let\marginnoterightadjust\FrameSep
}
\endgroup

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% raccourcis Papiray % raccourcis Papiray et patronymes

\newcommand\mk{Markus~\tpc{Kohm}\xspace}
\newcommand\rr{Raymond~\tpc{Rochedieu}\xspace}
\newcommand\pr{\tpc{Papiray}\xspace}
\newcommand\prp{\tpc{Papiray} {précise} :\xspace}
\newcommand\ks{\texttt{KOMA-Script}\xspace}
\newcommand\kss{\texttt{KOMA-Script2}\xspace}
\newcommand\ksss{\texttt{KOMA-Script3}\xspace}
\newcommand\ksc{\texttt{KOMA-Script-classe}\xspace}
\newcommand\kso{\texttt{KOMA-Script-Option}\xspace}
\newcommand\ko{\texttt{KOMAoption}\xspace}
\newcommand\kos{\texttt{KOMAoptions}\xspace}
\newcommand\ps{\texttt{PostScript}\xspace}

\newcommand\nom[2]{#1~\tpc{#2}} % pour indiquer un prénom en écriture normale suivi du nom en petites capitales % remplace \newcommand\nom[2]{#1~\textsc{#2}}

\newcommand{\gof}[1]{\og{}#1\fg{}} % pour mettre un texte entre guillemets français, saisissez dans votre document : \gof{texte à mettre entre guillemets} (remplace \og & \fg) - code extrait de latex pour l'impatient 
\newcommand{\gui}[1]{\enquote{#1}} % pour mettre un texte entre guillemets dans la langue babel du texte, saisissez dans votre document : \gui{texte à mettre entre guillemets} (remplace \frquote) - inspiré de babel-frenchb
\newcommand\cad{c'est-à-dire \xspace} 

 % \xspace dans une commande teste ce qui suit : si c'est une ponctuation ou des accolades, { et/ou }, la commande \xspace ne fera rien, dans les autres cas, elle ajoute une espace.

\newcommand\kst{KOMA-Strict} % clin d'oeil
\newcommand\grul{GRAppA (Université de Lille 3)\xspace} 

\newcommand\nor{nouvelle orthographe (orthographe rectifiée de 1990)\xspace} 
\newcommand\Nor{Nouvelle orthographe (orthographe rectifiée de 1990)\xspace}  % en début de phrase

\newcommand\ffir[1]{figure~\ref{#1}} % pour mettre le numéro de chapitre et de section
\newcommand\ffip[1]{figure~\pageref{#1}} % pour mettre le numéro de page
\newcommand\ffivr[1]{figure~\vref{#1}} % insère le numéro de section et remplace le numéro de page par « page précédente » ou « page suivante » si la référence se trouve à la page précédente ou suivante. 

%\newcommand\Lfir[1]{La figure~\ref{#1}}
\newcommand\Lfir[1]{La figure~\vpageref{#1}} % insère le numéro de page et le remplace par « page précédente » ou «page suivante » si la référence se trouve à la page précédente ou suivante. 
\newcommand\lfi[1]{la figure~\ref{#1}}
\newcommand\dfir[1]{dans la figure~\ref{#1}}
\newcommand\Dfir[1]{Dans la figure~\ref{#1}}

\newcommand\dsffir[2]{dans les figures~\ref{#1} et \ref{#2}}
\newcommand\dsfffir[3]{dans les figures~\ref{#1}, \ref{#2} et \ref{#3}}
\newcommand\dfip[1]{dans la figure~\vref{#1}}
\newcommand\dfivr[1]{dans la figure~\vpageref{#1}}
\newcommand\dfif[1]{dans la figure~\fullref{#1}}% insère directement les références sous la forme « 2.1 page 2 ». 

\newcommand\Dfip[1]{Dans la figure~\pageref{#1}}
\newcommand\Dfivr[1]{Dans la figure~\vref{#1}} 
\newcommand\Dsffir[2]{Dans les figures~\ref{#1} et \ref{#2}}
\newcommand\Dsfffir[3]{Dans les figures~\ref{#1}, \ref{#1} et \ref{#3}}

\newcommand\fir[1]{voir la figure~\ref{#1}}
\newcommand\fip[1]{voir la figure~\pageref{#1}}
\newcommand\fivr[1]{voir la figure~\vref{#1}}
\newcommand\fivp[1]{voir la figure~\vpageref{#1}} % insère le numéro de page et le remplace par « page précédente » ou «page suivante » si la référence se trouve à la page précédente ou suivante. 
\newcommand\fif[1]{voir la figure~\fullref{#1}} % insère directement les références sous la forme « 2.1 page 2 ». 

\newcommand\altavr[1]{à la table~\vref{#1}}

\newcommand\Lta[1]{La table~\ref{#1}}
\newcommand\lta[1]{la table~\ref{#1}}
\newcommand\atar[1]{table~\ref{#1}}
\newcommand\atavr[1]{table~\vref{#1}}
\newcommand\Latavr[1]{La table~\vref{#1}}
\newcommand\latavr[1]{La table~\vref{#1}}

\newcommand\vtar[1]{voir la table~\ref{#1}}
\newcommand\vtavr[1]{voir la table~\vref{#1}}

\newcommand\detar[1]{de la table~\ref{#1}}
\newcommand\detavr[1]{de la table~\vref{#1}}

\newcommand\dtar[1]{dans la table~\ref{#1}}
\newcommand\dtavr[1]{dans la table~\vref{#1}}

\newcommand\Dtar[1]{Dans la table~\ref{#1}}
\newcommand\Dtavr[1]{Dans la table~\vref{#1}}

\newcommand\aser[1]{section~\ref{#1}}
\newcommand\asevr[1]{section~\vref{#1}}

\newcommand\vser[1]{voir la section~\ref{#1}}
\newcommand\vsevr[1]{voir la section~\vref{#1}}

\newcommand\dser[1]{dans la section~\ref{#1}}
\newcommand\dsevr[1]{dans la section~\vref{#1}}

\newcommand\Dser[1]{Dans la section~\ref{#1}}
\newcommand\Dsevr[1]{Dans la section~\vref{#1}}

\newcommand\apar[1]{paragraphe~\ref{#1}}
\newcommand\apavr[1]{paragraphe~\vref{#1}}

\newcommand\vpar[1]{voir le paragraphe~\ref{#1}}
\newcommand\vpavr[1]{voir le paragraphe~\vref{#1}}

\newcommand\dpar[1]{dans le paragraphe~\ref{#1}}
\newcommand\dpavr[1]{dans le paragraphe~\vref{#1}}

\newcommand\Dpar[1]{Dans le paragraphe~\ref{#1}}
\newcommand\Dpavr[1]{Dans le paragraphe~\vref{#1}}

% commandes raccourcis logos pour écrire les logos avec TeX dans le nom - nécessite {hologo} - 

\newcommand{\lat}{\hologo{LaTeX}\xspace}
\newcommand{\lata}{\hologo{(La)TeX}\xspace}
\newcommand{\latd}{\hologo{LaTeX2e}\xspace}
\newcommand{\latt}{\hologo{LaTeX3}\xspace}

\newcommand{\luat}{\hologo{LuaTeX}\xspace}
\newcommand{\lual}{\hologo{LuaLaTeX}\xspace}

\newcommand{\lyx}{\hologo{LyX}\xspace}
\newcommand{\mik}{\hologo{MiKTeX}\xspace}

\newcommand{\tex}{\hologo{TeX}\xspace}
\newcommand{\texn}{\hologo{TeX}nishe\xspace}

\newcommand{\xel}{\hologo{XeLaTeX}\xspace}
\newcommand{\xet}{\hologo{XeTeX}\xspace}

\newcommand{\la}{\hologo{La}\xspace}
\newcommand{\xe}{\hologo{Xe}\xspace}

\newcommand{\amsl}{\hologo{AmSLaTeX}\xspace}
\newcommand{\amst}{\hologo{AmSTeX}\xspace}

\newcommand{\bib}{\hologo{BibTeX}\xspace}
\newcommand{\cont}{\hologo{ConTeXt}\xspace}
\newcommand{\ete}{\hologo{eTeX}\xspace}
\newcommand{\Ext}{\hologo{ExTeX}\xspace}

\newcommand{\lattx}{\hologo{LaTeXTeX}\xspace}

\newcommand{\pdft}{\hologo{pdfTeX}\xspace}
\newcommand{\pdfl}{\hologo{pdfLaTeX}\xspace}

\newcommand{\sli}{\hologo{SLiTeX}\xspace}
\newcommand{\tet}{\hologo{teTeX}\xspace}

\newcommand{\vir}{\hologo{virTeX}\xspace}
\newcommand{\vte}{\hologo{VTeX}\xspace}

%\begin{macro}{\eTeX}
%   This may already be defined.
%    \begin{macrocode}
\providecommand*{\eTeX}{\ensuremath{\varepsilon}-\TeX}
\providecommand*{\NTS}{%
  \leavevmode\hbox{$\cal N\kern-0.35em\lower0.5ex\hbox{$\cal T$}%
  \kern-0.2emS$}}
%    \end{macrocode}
% \end{macro}
%

% raccourcis controblic

\newcommand\co{\textbackslash} % controblic
\newcommand\cog{\textbackslash\textbf} % controblic - texte gras
\newcommand\coi{\textbackslash\textit} % controblic - texte italique
\newcommand\coig[1]{\textbackslash\textit{\textbf{#1}}} % controblic - texte italique gras

\newcommand\cott[1]{\textbackslash{\texttt{#1}}} % controblic + commande en texte particulier

% raccourcis mise en forme de l'écriture

\RequirePackage{frcursive}% s'utilise entre les commandes \begin{cursive} et \end{cursive} charge french cursive 
\RequirePackage{cabin} % charge la police cabin - seul le texte passé en argument de \textsf sera impacté

\newcommand\ted{\textup} % TExte Droit
\newcommand\tep{\textsl} % TExte Penché
\newcommand\tit{\textit} % Texte ITalique
\newcommand\tig[1]{\textit{\textbf{#1}}} % Texte Italique Gras
\newcommand\teg{\textbf} % TExte Gras
\newcommand\tpc{\textsc} % Texte Petites Capitales
\newcommand\ttt{\texttt} % TexTe Type machine à écrire - style Courier
\newcommand\tti[1]{\texttt{\textit{#1}}} % TexTe Italique type machine à écrire - style Courier 

\newcommand\tse{\textsf} % Texte Sans Empattement de type sans sérif - style courier et Arial (ou Helvetica)
\newcommand\tee{\textsuperscript} % Texte En Exposant - réduit la taille du caractère et le passe « au-dessus »

\newcommand*{\Molek}[2]{#1\textsubscript{#2}}
\newcommand*{\Molak}[2]{\tse{#1\textsubscript{#2}}}

\newcommand{\up}[1]{\textsuperscript{#1}} % gère la mise en exposant

% raccourcis divers

\renewcommand{\contentsname}{Table des matières} %  tableofcontents est au début mais ce n'est pas pour autant un sommaire (un sommaire ne fait que lister les titres niv 1 ou 2, pas plus. Mais compte-tenu des usages nous mettrons cette table des matières au début de l'ouvrage. 

 % encadrer un texte
 
 \newcommand{\atot}[1]{\makeatletter{}#1\makeatother{}} % pour encadrer un texte avec makeatletter-makeatother - code inspiré de latex pour l'impatient 
 
\newenvironment{centrer}{\parskip=4pt\par\nopagebreak\centering}{\par\noindent\ignorespacesafterend} 
% utilisation => \begin{centrer} le texte à centrer \end{centrer} % commande ne modifiant pas l'espace vertical 

%\newcommand{\hsp}{\hspace{20pt}}
\newcommand{\Epli}{\rule{\linewidth}{0.5mm}} % indiquer l'épaisseur d'une ligne dans un texte

% Environnement monexemple % proposition de christophe M. le 20 12 2016 à 23h31 - nécessite {pifont}

\newenvironment{monexemple}{%
   \begin{centrer}   \rule{0.5\linewidth}{0.8pt} \\  
   \noindent\tpc{Exemple}  \end{centrer} % 
   }{%
   \begin{centrer}   \rule{0.5\linewidth}{0.8pt} \end{centrer} %
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FAIRE LES ENCARTS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\RequirePackage{varwidth}

\newcommand\kotbox[1]{
\hspace*{-1cm}
\fbox{\begin{varwidth}{\textwidth}
#1
\end{varwidth}}
\nopagebreak
}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Eviter les orphelines au cas par cas
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newenvironment{memepage}{%
  \nopagebreak
}{
}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% commandes biblatex pour fabriquer une bibliographie
 
\RequirePackage[backend=biber,style=alphabetic,citestyle=authoryear]{biblatex} %  original papiray style
\addbibresource{mabib.bib}
%\RequirePackage[backend=biber,style=alpha,citestyle=authoryear,uniquelist=false,otherlangue=other]{natbib} %  original papiray style
%\addbibresource{mabib.bib}

 \RequirePackage{breakcites} % ajouter dans le préambule pour permettre une césure au sein d'une citation ou  dans une ligne de bibliographie trop longue (style apalike par exemple)

% Auto-contrôles

\listfiles % indique la version actuelle de tous les paquets chargés en consultant le fichier .log après compilation
\RequirePackage{layout} % permet, avec la commande \layout, d'afficher le gabarit de mise en page du document  

% On traite la langue en dernier

\RequirePackage[greek,english,german,french]{babel}\index{babel}\index{french}

\babeltags{gr=greek,en=english,de=german,fr=french} % syntaxe allégée qui permet l'usage des raccourcis \begin{de} et \end{de} ou \begin{en} et \end{en} pour encadrer ponctuellement du texte dans la langue indiquée

\RequirePackage[french]{varioref} % permet d'appeler une référence de label ou d'étiquette (vref)

\RequirePackage{caption} % paq caption à charger après babel/french
\RequirePackage{subcaption} % remplace les packs subfigure et subfig qui sont devenus obsolètes

\setkomafont{caption}{\footnotesize} % légende en petite police
\setkomafont{captionlabel}{\usekomafont{caption}} 

% générer l'index avec splitidx :  % remplace \makeidx - suggestion de Markus KOHM

\RequirePackage[useindex,makeindex]{splitidx}
\RequirePackage{idxlayout} % équilibre les colonnes de la dernière page

\KOMAoptions{DIV=last}

% "!  - % "| - % "@ % "" % indexation des 4 caractères spéciaux - ! - | - @ - " - % propositions pour @ => \"@   -  "@ - $@$
